﻿변경사항
=============

## v1.0.0

+ arkzip 정식 버전 릴리즈.

### v1.6.0

+ 유니코드 변환에 iconv 라이브러리를 사용.
+ desktop 설정 파일을 통해 프로그램을 실행시킬때, 실행 후 대기 커서가 발생하지 않도록 수정.

#### v1.6.1

+ libboost-filesystem을 프로그램에서 제외.

### v1.7.0

+ 압축파일의 체크섬을 검사하는 기능을 추가.
+ 유니코드 변환 오류를 수정.

#### v1.7.1

+ man 도움말의 링크가 깨져 버리던 문제 수정.

#### v1.7.2

+ 인자 검사 부분의 조건 검사 오류를 수정.

#### v1.7.3

+ 폴더를 생성하던 부분에 대한 오류를 수정.
+ 도움말을 업데이트.

#### v1.7.4

+ 체크 옵션에 관한 도움말을 업데이트.
+ 중복 파일 생성 시 발생하던 폴더 경로 무시를 수정(이제 부터 모든 중복 파일은 중복되는 파일이 위치한 경로에 풀리게 됩니다.)

#### v1.7.5

+ 압축해제 경로를 존재하지 않는 경로로 설정하지 못하도록 수정.
+ 압축해제 경로 검사에 realpath 패키지를 사용.

#### v1.7.6

+ 내부에서 처리되는 인코딩을 UCS-4로 수정.

### v1.8.0

+ 무결성 검사 옵션을 제외.
+ 메모리 검사 옵션을 추가.

### v1.9.0

+ 코드 페이지 지정 옵션을 추가.

#### v1.9.1

+ 코드 페이지 지정시, 정상적으로 적용되지 않던 문제 해결.

#### v1.9.2

+ changlog와 copying, authors에 UTF-8 BOM을 추가하여 문자깨짐 현상 방지.

#### v1.9.3

+ 테스트 버전과의 동기화를 위한 주석 추가.

#### v1.9.4

+ 7z 분할 압축 파일에 대한 연결 패턴을 추가.

#### v1.9.5

+ GUI에서 아이콘이 제대로 표시되지 않던 문제 해결.
+ 라이선스를 LGPL v3.0으로 수정.

#### v1.9.6

+ 프로그램의 구조적 변경.
+ 라이선스 정보 업데이트(Qt, libnotify, PCRE...).

#### v1.9.7

+ 라이선스 정보 업데이트(arklibrary...).

#### v1.9.8

+ 진행 막대기를 표현하는 부분을 부드럽게 움직이도록 수정.

#### v1.9.9

+ 사용된 프로그램 및 라이브러리에 대한 라이선스를 표시한 파일을 수정(License.txt).

#### v1.9.10

+ 진행 막대기가 0 부터 시작하지 않던 문제 해결.

#### v1.9.11

+ -s 옵션을 비롯한 옵션이 동작하지 않던 문제를 해결.

#### v1.9.12

+ gui 모드에서 출력되는 오류 메시지에 html 태그를 적용.

#### v1.9.13

+ 현재 몇번째 파일을 압축해제 중인지 표시하는 기능을 추가.
+ gui 모드에서 출력되는 오류 메시지의 색상값을 일부 수정.

#### v1.9.14

+ cui에서 현재 몇번째 파일이 풀리는지 표시하는 부분을 한칸 뛰움.

#### v1.9.15

+ gui에서 작업 완료후 진행 막대기가 0이 되던 문제 해결.

#### v1.9.16

+ 도움말에서 삭제된 기능 --check(파일 오류 검사)에 대한 설명을 제거하고, --test에 대한 설명을 추가.

## v2.0.0

+ qt에 기반한 프로그램으로 모든 코드를 재작성.
+ libnotify를 사용하지 않게 됨.
+ realpath 프로그램을 사용하지 않게 됨.
+ License.txt 정보 업데이트.
+ changelog, install 문서를 markdown문법으로 재작성.
+ PCRE 라이브러리를 사용하지 않게 됨.
+ Boost 라이브러리 패키지의 Program_options 라이브러리를 사용하여 옵션을 처리하도록 함.
+ 인코딩 변환에 iconv 대신 qt 라이브러리를 사용.
+ 보다 엄격한 옵션 검사를 지원.
+ 보다 엄격한 작업 조건 검사를 지원.
+ cui또는 gui에서만 사용 가능했던 옵션을 인터페이스에 상관없이 사용할수 있게 됨.
+ gui에서 압축 해제 진행창을 중앙 배치하는 작업을 수행하지 않게 함.
+ gui에서 작업 내역을 숨길수 있도록 함.
+ gui에서 트레이 아이콘을 지원하도록 함.
+ cui 인터페이스에서 표준 에러만 리다이렉션하였을때, 오류 내용이 보다 정확하게 구분될수 있도록 하기 위해 보다 상세한 정보를 기술하도록 함.
+ 확장자 연결된 데스크톱 설정 파일의 이름을 ArkGUI에서 arkzip으로 변경.
+ terminal 인터페이스의 경우, 색상 강조를 지원하도록 함. 예컨데, 오류 메시지를 빨간색으로 강조되게 됨.
+ cui에서 출력이 리다이렉션 되고있거나 환경이 터미널이 아니라면 터미널 제어 기능이 요구되는 기능과 진행 상태 표시 등의 부가정보를 제외시킨 정보를 출력하게 함.
+ 인자의 가장 마지막 값을 저장 경로로 지정하던 것을 --output-dir 옵션을 통해 지정하도록 변경.
+ 저장 경로 옵션을 생략할시 현재경로에 저장하도록 함.
+ hex 코드로된 암호를 입력받는 옵션을 추가함.
+ arkzip 프로그램에서 도움말을 보다 예쁘게 수정.
	+ arkzip 프로그램에서 도움말을 호출할시 나오는 옵션들을 그룹으로 묶어 출력하도록 함.
+ cui에서 모든 작업 마다 작업 진행율을 표시하던 것을 작업 현황을 일정 간격 마다 출력하는것으로 변경 함.
+ codepage 옵션에 자동으로 코드 페이지를 파악하는 옵션을 추가.
+ 기존에 옵션을 처리하던 arkzip bash 스크립트를 c++로 재작성함.
+ gui에서 버튼과 트레이 아이콘 메뉴에 아이콘을 추가.
+ 보다 상세한 오류 로그를 제공합니다.
	+ 기존에 출력되던 오류 코드 대신에 오류 코드에 해당되는 오류 메시지를 출력합니다.
+ man page를 수정.
	+ 변경된 내용에 맞게 재작성함.
	+ 보다 상세한 설명을 추가함.
+ arkzip 패키지를 제거할시 발생하던 desktop 설정 제거 실패를 해결.
+ 각 확장자 종류 별로 아이콘이 추가됨.
+ 각 확장자 종류 별로 데스크톱 파일을 연결함.
+ z, xz, bz2, gz, lzh, acb, ace, arj, rar, wim, 7z, tar, zip, alz, egg확장자에 대한 mime magic을 추가함.

### v2.1.0

+ gui에서 오류가 발생하였을시 바로 창을 닫지 않게 함.
+ gui에서 오류가 발생하였을시 로그를 보여주게 함.

#### v2.1.1

+ gui에서 오류 로그를 숨긴뒤 창 세로 크기를 늘렸을 경우 위젯들 간의 거리가 벌어지던 현상 수정.

#### v2.1.2

+ 512x512 크기의 아이콘을 제외함.
+ 작업 로그 보이기 버튼을 클릭할시 창 높이를 작업 로그 숨기기 버튼을 클릭하였을때의 창 높이로 복구되게 함.
+ 작업 로그 숨김 상태에서 창 높이를 조정하면 현재 창 높이 만큼의 크기에 작업 로그를 보이게 함(창이 위젯들의 최소 높이 합 보다 커야 함).
+ 7z, ace, arj, bh, bz2, gz, iso, lzh, lzma, rar, tar, wim, xz, z, zip 파일 타입에 대한 mime 설정을 제거함.
+ 7z, ace, arj, bh, bz2, gz, iso, lzh, lzma, rar, tar, wim, xz, z, zip 파일 타입에 대한 아이콘을 제거함.
+ arkzip으로 시작하던 mime-type을 x로 시작하도록 수정.
+ 파일 종류 별로 연결된 아이콘이 정상적으로 표시되지 않던 문제 해결.

#### v2.1.3

+ 설치시 사용되지 않는 xdg-utils에 대한 의존성을 패키지 설치 파일에서 제거.
+ 암호에 관련된 설명을 man 페이지에 보다 상세히 기술함.
+ gui에서 암호를 묻는 부분에서 오류가 나던 문제 해결.

### v2.2.0

+ 의존 패키지 목록에서 의존하는 패키지 libboost-program-options-dev를 libboost-program-options1.46.1로 수정.
+ skip-pass 옵션을 추가. 이 옵션을 사용하면, 암호를 물어보지 않습니다.
+ 명령행에서 지정된 암호가 적용되지 않던 문제 해결.
+ 일괄 압축 해제 시 한번 설정된 암호는 압축 해제될 모든 파일에 대해 적용되도록 함.
+ gui에서 중복 파일 알림 메시지의 색상을 보다 진한 노란색으로 변경.

#### v2.2.1

+ gui에서 중복 파일 알림 메시지에 강조 태그를 적용.

#### v2.2.2

+ 창이 정상적으로 닫기지 않던 문제 해결.
+ gui에서 암호 입력 창이 떠있을시 프로그램이 종료되지 않던 문제 해결.
+ gui에서 암호 입력 대화창이 표시되었을때, 트레이 아이콘의 보이기/숨김 토글옵션과 일시정지 옵션을 비활성화 하도록 수정.

#### v2.2.3

+ 컴파일 시 발생하는 In lambda function capture of non-variable error를 수정.

#### v2.2.4

+ boost-program-options 라이브러리를 멀티 쓰레드용으로 변경.

#### v2.2.5

+ 의존 패키지 libboost-program-options1.46.1를 libboost-program-options-dev로 수정.

#### v2.2.6

+ 패키지 설치 파일에서 의존 패키지가 갱신되지 않았던 점 수정.

#### v2.2.7

+ 패키지 설치 파일의 의존 패키지 목록에서 libboost-program-options-dev를 제거.
+ libboost-program-options를 정적으로 링크하도록 수정.
+ arkcore 라이브러리를 공유 라이브러리에서 정적 라이브러리로 수정하여 링크.
+ 소스에서 test mode용 arkcore 라이브러리 경로 설정 코드를 제거함.

#### v2.2.8

+ man 페이지에 libboost-program-options의 버전 정보를 추가함.
+ windows에서만 지원되는 nsis, udf, ace 포멧에 대한 확장자 연결, 아이콘, 설명을 제거.
+ gui에서 기존에 주의 수준의 메시지는 무시하고 닫기던 점을 경고 수준의 메시지와 마찬가지로 확인하도록 수정.
+ 모든 종료 코드에 대한 의미를 설정함.
	+ 모든 경고 수준의 오류에 오류 코드를 부여. ex) 파일	 존재하지 않음, 파일 여는데 문제 생김 등... 
	+ 각 종료 코드에 대한 설명을 man페이지에 추가함.
+ gui에서 오류 코드를 출력시 압축 파일과 압축 해제 중인 파일 내용을 강조하도록 수정.
+ windows 환경에서 사용불가능한 문자가 포함된 경로에 압축 해제시 지정되지 않은 경로로 풀리던 문제를 수정.
+ gui에서 압축 파일 경로와 압축 해제 대상을 표시할때, 단어 줄바꿈을 하도록 설정.
+ 7z 분할 압축 파일을 추가함.
	+ 아이콘 추가.
	+ 확장자 정보 추가.
	+ 확장자를 arkzip과 연결함.
+ alz, j2j 아이콘을 수정함.

### v2.3.0

+ GUI 모드에서 기본으로 보여질 작업 내역 박스 크기를 조정.
+ GUI 모드에서 창의 가로 길이를 최소한으로 줄일수 있도록 수정.
+ man 페이지에서 종료 코드에 대한 설명을 다듬음.
+ hv3 확장자에 대한 설명, 아이콘, 확장자 정보를 추가하고 arkzip 연결 프로그램에 등록함.
+ 일부 오류 메시지에서 다음 문구를 수정. \`에러' -> '오류가'
+ 코드 페이지 지정 옵션을 수정.
	+ man 페이지의 설명을 수정함.
	+ 다음 코드 페이지를 지정하는 이름이 추가되었습니다. 쉼표로 구분된 각 별명은 CP949과 UHC와 같은 동일한 대상임의 의미합니다.
		+ jpn -> CP932, shift_jis, Shift-JIS, jpn
		+ kor -> CP949, UHC, kor
	+ 다음 코드 페이지가 추가되었습니다. 각 줄에 쉼표로 구분된 이름은 해당 코드 페이지에 대한 별칭입니다.
		+ CP0, acp
		+ CP1, oemcp
		+ CP2, maccp
		+ CP37, ibm037
		+ CP437, ibm437
		+ CP500, ibm500
		+ CP708, asmo-708
		+ CP709
		+ CP710
		+ CP720, dos-720
		+ CP737, ibm737
		+ CP775, ibm775
		+ CP850, ibm850
		+ CP852, ibm852
		+ CP855, ibm855
		+ CP857, ibm857
		+ CP858, ibm00858
		+ CP860, ibm860
		+ CP861, ibm861
		+ CP862, dos-862
		+ CP863, ibm863
		+ CP864, ibm864
		+ CP865, ibm865
		+ CP866
		+ CP869, ibm869
		+ CP870, ibm870
		+ CP874, windows-874
		+ CP875
		+ CP936, gb2312
		+ CP950, big5
		+ CP1026, ibm1026
		+ CP1047, ibm01047
		+ CP1140, ibm01140
		+ CP1141, ibm01141
		+ CP1142, ibm01142
		+ CP1143, ibm01143
		+ CP1144, ibm01144
		+ CP1145, ibm01145
		+ CP1146, ibm01146
		+ CP1147, ibm01147
		+ CP1148, ibm01148
		+ CP1149, ibm01149
		+ CP1200, utf-16, utf16, utf-16le, utf16le
		+ CP1201, unicodefffe, utf-16be, utf16be
		+ CP1250, windows-1250
		+ CP1251, windows-1251
		+ CP1252, windows-1252
		+ CP1253, windows-1253
		+ CP1254, windows-1254
		+ CP1255, windows-1255
		+ CP1256, windows-1256
		+ CP1257, windows-1257
		+ CP1258, windows-1258
		+ CP1361, johab
		+ CP10000, macintosh
		+ CP10001, x-mac-japanese
		+ CP10002, x-mac-chinesetrad
		+ CP10003, x-mac-korean
		+ CP10004, x-mac-arabic
		+ CP10005, x-mac-hebrew
		+ CP10006, x-mac-greek
		+ CP10007, x-mac-cyrillic
		+ CP10008, x-mac-chinesesimp
		+ CP10010, x-mac-romanian
		+ CP10017, x-mac-ukrainian
		+ CP10021, x-mac-thai
		+ CP10029, x-mac-ce
		+ CP10079, x-mac-icelandic
		+ CP10081, x-mac-turkish
		+ CP10082, x-mac-croatian
		+ CP12000, utf-32, utf32, utf32le, utf-32le
		+ CP12001, utf-32be, utf32be
		+ CP20000, x-chinese_cns
		+ CP20001, x-cp20001
		+ CP20002, x_chinese-eten
		+ CP20003, x-cp20003
		+ CP20004, x-cp20004
		+ CP20005, x-cp20005
		+ CP20105, x-ia5
		+ CP20106, x-ia5-german
		+ CP20107, x-ia5-swedish
		+ CP20108, x-ia5-norwegian
		+ CP20127, us-ascii
		+ CP20261, x-cp20261
		+ CP20269, x-cp20269
		+ CP20273, ibm273
		+ CP20277, ibm277
		+ CP20278, ibm278
		+ CP20280, ibm280
		+ CP20284, ibm284
		+ CP20285, ibm285
		+ CP20290, ibm290
		+ CP20297, ibm297
		+ CP20420, ibm420
		+ CP20423, ibm423
		+ CP20424, ibm424
		+ CP20833, x-ebcdic-koreanextended
		+ CP20838, ibm-thai
		+ CP20866, koi8-r
		+ CP20871, ibm871
		+ CP20880, ibm880
		+ CP20905, ibm905
		+ CP20924, ibm00924
		+ CP20932, euc-jp
		+ CP20936, x-cp20936
		+ CP20949, x-cp20949
		+ CP21025, cp1025
		+ CP21027
		+ CP21866, koi8-u
		+ CP28591, iso-8859-1
		+ CP28592, iso-8859-2
		+ CP28593, iso-8859-3
		+ CP28594, iso-8859-4
		+ CP28595, iso-8859-5
		+ CP28596, iso-8859-6
		+ CP28597, iso-8859-7
		+ CP28598, iso-8859-8
		+ CP28599, iso-8859-9
		+ CP28603, iso-8859-13
		+ CP28605, iso-8859-15
		+ CP29001, x-europa
		+ CP38598, iso-8859-8-i
		+ CP50220, iso-2022-jp
		+ CP50221, csiso2022jp
		+ CP50222, iso-2022-jp
		+ CP50225, iso-2022-kr
		+ CP50227, x-cp50227
		+ CP50229
		+ CP50930
		+ CP50931
		+ CP50933
		+ CP50935
		+ CP50936
		+ CP50937
		+ CP50939
		+ CP51932, euc-jp
		+ CP51936, euc-cn
		+ CP51949, euc-kr
		+ CP51950
		+ CP52936, hz-gb-2312
		+ CP54936, gb18030
		+ CP57002, x-iscii-de
		+ CP57003, x-iscii-be
		+ CP57004, x-iscii-ta
		+ CP57005, x-iscii-te
		+ CP57006, x-iscii-as
		+ CP57007, x-iscii-or
		+ CP57008, x-iscii-ka
		+ CP57009, x-iscii-ma
		+ CP57010, x-iscii-gu
		+ CP57011, x-iscii-pa
		+ CP65000, utf-7, utf7
		+ CP65001, utf-8, utf8
	+ 코드페이지 수동 지정 기능이 추가되었습니다. \`CP + 코드페이지 번호'로 코드 페이지를 수동으로 지정 할 수 있습니다.
	+ codepage-list 옵션을 추가함. 사용가능한 코드 페이지를 확인 할 수 있음.
	+ man 페이지에 사용 가능한 코드 페이지 목록을 추가함.
+ 코드 페이지 지정시 파일 목록에 대해서만 적용되도록 수정. (사용자가 지정한 코드페이지를 암호에 적용하지 않게 함.)
+ 파일 열기에 실패했을 경우 출력되는 오류 메시지에 파일 경로도 함께 표시하도록 수정함.
+ UNIX 에서 압축한 ZIP 파일의 코드페이지를 무조건 UTF8로 처리하지 않게 함.

#### v2.3.1

+ ARK 라이브러리 로드 실패시 프로그램이 종료되지 않고 오작동 하던 문제 수정.
+ 코드 페이지가 지정되어도 무시되던 문제 해결.
+ 코드 페이지 변환에 icu 라이브러리를 사용.
+ 코드 페이지 번호로 코드페이지를 지정하는 기능을 삭제.
+ 코드 페이지 설명을 수정. (man 페이지)
+ 2.3.0에 새롭게 정의되었던 코드 페이지를 모두 무효화하고, icu에서 지원하는 코드 변환기 목록으로 바꿈. 2.3.0 버전 이전에 지원하던 auto, kor, utf8, jpn은 동일하게 유지됨. 상세한 내용은 man 페이지를 참조할것.
+ 코드 변환기 준비 실패에 대한 오류를 추가함.
+ \`test.te st.zip'과 같은 형태에서 중복 회피명을 만들게 되면, 'test (d1).te st.zip'이 되던 문제를 수정.

#### v2.3.2

+ 코드 페이지 변환에 icu 라이브러리 대신 QT QTextCodec을 사용하도록 변경함.
	+ 2.3.1 버전에서 추가된 모든 지원 코드 페이지가 삭제되고, 관련 설명도 삭제됨.

### v2.4.0

+ gui > infoBrowser에 출력되는 메시지가 박스 경계에서 줄바꿈 되도록 변경.
+ gui > 압축 파일 경로와 압축 해제 내용을 표시하는 라벨의 내용이 라벨 경계에서 줄바꿈 하도록 변경.
+ 분할 저장 폴더 생성 실패에 대한 오류에 대한 메시지를 수정.
+ 코드페이지 지정시 전체 압축 해제 진행율이 표시되지 않던 문제 해결.
+ hv3(꿀뷰 전용 포멧)에 대한 magic number를 추가함.
+ hv3이 풀리지 않던 문제 해결.
	+ hv3 해제에 [libunhv3](https://github.com/Thestars3/libunhv3) 라이브러리를 사용.
+ 코드 페이지 jpn이 적용되지 않던 문제 수정.
+ man 페이지와 arkzip 코드 페이지 옵션에 있는 코드 페이지 리스트에서 중복되는 코드 페이지를 제거.
+ 오류코드 13과 1을 자리바꿈하고, 오류 코드 1의 의미를 보다 모호하고 광범위한 오류를 가리키는 것으로 변경.
+ 기존의 오류코드 95에 해당하는 오류를 오류코드 1로 설정하도록 변경.
+ 'TAK_2.3.0.zip'과 같은 이름을 가진 압축 파일을 -s을 주어 풀때, \`TAK_2.3 (d1).0'식으로 잘못된 위치에 중복 회피값을 넣던 점 수정.
+ 코드 페이지를 지정한 상태에서 특수문자가 파일목록에 포함된 압축 파일을 풀때 발생하던 파일명 깨짐 현상 수정.

#### v2.4.1

+ libunhv3를 1.1.2버전으로 교체.
	+ hv3 파일을 풀때, 전체 진행율이 표시되지 않던 점 수정.
	+ 이벤트 처리시, 압축 해제 중인 파일에 대해 압축 해제 대상 경로를 포함하여 표시하지 않도록 수정.
	+ 오류 보고시, 중복 회피 처리된 파일명이 아닌 원본 파일명으로 보고하도록 수정.
	+ HDP 변환 실패시, 부분 진행율이 99로 갔다, 다시 줄어드는 현상 수정.
	+ 메모리 누수를 해결.
	+ 폴더가 포함된 경우, 해당 경로를 생성하여 처리하도록 개선.
+ hv3 압축 해제 후, 종료코드를 얻지 못하던 점 수정.
+ GUI 모드에서 hv3 파일을 푼뒤 오류가 있어도 바로 창이 닫기던점 수정.
+ GUI 모드에서 크기 재조정후 크기가 최적화되도록 수정.
+ GUI 모드에서 '작업 내역 보이기' 버튼과 '닫기' 버튼 사이에 공백이 생기던 문제를 해결.
+ 일부 오류 메시지를 수정.

#### v2.4.2

+ 재부팅 후, 공유 라이브러리를 불러오지 못하던 문제 수정.
+ 버전 옵션(--version)을 추가.

#### v2.4.3

+ gui 진행표시창에서 작업 내역을 보여주는 부분에서 외부 링크를 열 수 있도록 수정.
+ gui 분할 저장 폴더 생성 실패시, 기본 위치에 대한 바로가기 링크를 추가함.
+ gui 진행표시창에서 링크를 클릭 할 시, 작업 내역이 사라지던 점 수정.

#### v2.4.4

+ gui : 진행 표시 라벨이 변경된 이후 길이가 창 보다 짧을 경우 곧 바로 창의 길이가 축소되도록 수정.
+ gui : 대량의 파일을 압축해제 할 때 작업 내역을 펼친 채로 작업을 하면 프로그램이 멈추던 점 수정.
+ arkzip --version 옵션 사용시 버전 정보가 2.4.2로 잘못 표시되고 있던 점 수정.
